/* asm-x86-64-gcc.h -- (C) Geoffrey Reynolds, July 2006.

   Inline x86-64 assember routines for GCC.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
*/

/* This file may be included from a number of different headers. It should
   only define FEATURE if NEED_FEATURE is defined but HAVE_FEATURE is not.
*/

#if defined(NEED_memset32_8) && !defined(HAVE_memset32_8)
#define HAVE_memset32_8
/* store count copies of x starting at dst. count is a multiple of 8.
 */
static inline
void memset32_8(uint_fast32_t *dst, uint_fast32_t x, uint_fast32_t count)
{
  register uint64_t tmp;
  register uint64_t *ptr;

  asm ("cld\n\t"
       "rep; stosq"
       : "=c" (tmp), "=D" (ptr),
         "=m" (*(struct { uint64_t dummy[count/2]; } *)dst)
       : "a" (x << 32 | x), "0" (count/2), "1" (dst)
       : "cc" );
}
#endif
